TYVJ4239 [NOIP2015提高组DayT3]斗地主
P2668 斗地主
题目描述
牛牛最近迷上了一种叫斗地主的扑克游戏。斗地主是一种使用黑桃、红心、梅花、方片的A到K加上大小王的共54张牌来进行的扑克牌游戏。在斗地主中, 牌的大小关系根据牌的数码表示如 下:3<4<5<6<7<8<9<10<J<Q<K<A<2<小 王<大王,而花色并不对牌的大小产生影响。每一局游戏中,一副手牌由n张牌组成。游戏者每次可以根据规定的牌型进行出牌,首先打光自己的手牌一方取 得游戏的胜利。
现在,牛牛只想知道,对于自己的若干组手牌,分别最少需要多少次出牌可以将它们打光。请你帮他解决这个问题。
需要注意的是,本题中游戏者每次可以出手的牌型与一般的斗地主相似而略有不同。
具体规则如下:
本题数据随机,不支持hack,要hack或强力数据请点击这里
输入输出格式
输入格式:
第一行包含用空格隔开的2个正整数T和n,表示手牌的组数以及每组手牌的张数。
接下来T组数据,每组数据n行,每行一个非负整数对aibi表示一张牌,其中ai示牌的数码,bi表示牌的花色,中间用空格隔开。特别的,我们用1
来表示数码A,11表示数码J,12表示数码Q,13表示数码K;黑桃、红心、梅花、方片分别用1-4来表示;小王的表示方法为01,大王的表示方法为
02。
输出格式:
共T行,每行一个整数,表示打光第i手牌的最少次数。
输入输出样例
- 1 8
- 7 4
- 8 4
- 9 1
- 10 4
- 11 1
- 5 1
- 1 4
- 1 1
- 3
- 1 17
- 12 3
- 4 3
- 2 3
- 5 4
- 10 2
- 3 3
- 12 2
- 0 1
- 1 3
- 10 1
- 6 2
- 12 1
- 11 3
- 5 2
- 12 4
- 2 2
- 7 2
- 6
说明
样例1说明
共有1组手牌,包含8张牌:方片7,方片8,黑桃9,方片10,黑桃J,黑桃5,方片A以及黑桃A。可以通过打单顺子(方片7,方片8,黑桃9,方片10,黑桃J),单张牌(黑桃5)以及对子牌(黑桃A以及方片A)在3次内打光。
对于不同的测试点, 我们约定手牌组数T与张数n的规模如下:
数据保证:所有的手牌都是随机生成的。
95分。。。卡到极限了,尽力了
- #include <iostream>
- #include <cstdio>
- #include <cstdlib>
- #include <cstring>
- #include <algorithm>
- #include <queue>
- #define min(a, b) ((a) < (b) ? (a) : (b))
- #define max(a, b) ((a) > (b) ? (a) : (b))
- inline void swap(int &x, int &y)
- {
- long long tmp = x;x = y;y = tmp;
- }
- inline void read(int &x)
- {
- x = ;char ch = getchar(), c = ch;
- while(ch < '' || ch > '')c = ch, ch = getchar();
- while(ch <= '' && ch >= '')x = x * + ch - '', ch = getchar();
- if(c == '-')x = -x;
- }
- const int INF = 0x3f3f3f3f;
- int t, n, cnt[], tmp, ans, tmp2, tmp3, tmp4;
- char s[];
- //当前正在打第step步, 剩余now个
- void dfs(int step, int now)
- {
- ans = min(ans, step - + now);
- if(step > ans)return;
- //枚举三顺子
- if(tmp3 > && now >= )
- {
- for(register int i = ;i <= ;++ i)
- {
- if(cnt[i] > && cnt[i + ] >= )
- {
- cnt[i] -= , cnt[i + ] -= ;
- tmp3 -= ;tmp2 -= ;
- dfs(step + , now - );
- register int j = i + ;
- int t = ;
- for(;j <= ;++ j)
- {
- if(tmp3 < )break;
- if(cnt[j] > ) cnt[j] -= , ++ t, tmp3 -= , tmp2 -= , dfs(step + , now - (j - i + ) * );
- else break;
- }
- -- j;
- for(;j >= i + ;-- j) cnt[j] += ;
- cnt[i] += , cnt[i + ] += ;
- tmp3 += + t;tmp2 += + t;
- }
- }
- }
- //枚举双顺子
- if(tmp2 > && now >= )
- {
- for(register int i = ;i <= ;++ i)
- {
- if(cnt[i] > && cnt[i + ] >= && cnt[i + ] >= )
- {
- cnt[i] -= , cnt[i + ] -= , cnt[i + ] -= ;
- tmp2 -= ;
- dfs(step + , now - );
- register int j = i + ;
- int t = ;
- for(;j <= ;++ j)
- {
- if(tmp2 < )break;
- if(cnt[j] > ) cnt[j] -= , tmp2 -= , dfs(step + , now - (j - i + ) * );
- else break;
- }
- -- j;
- for(;j >= i + ;-- j) cnt[j] += ;
- cnt[i] += , cnt[i + ] += , cnt[i + ] += ;
- tmp2 += + t;
- }
- }
- }
- //枚举单顺子
- if(now >= )
- {
- for(register int i = ;i <= ;++ i)
- {
- if(cnt[i] && cnt[i + ] && cnt[i + ] && cnt[i + ] && cnt[i + ])
- {
- -- cnt[i], -- cnt[i + ], -- cnt[i + ], -- cnt[i + ], -- cnt[i + ];
- int t3 = , t4 = , t2 = ;
- if(cnt[i] == ) -- tmp4, ++ t4;
- if(cnt[i + ] == ) -- tmp4, ++ t4;
- if(cnt[i + ] == ) -- tmp4, ++ t4;
- if(cnt[i + ] == ) -- tmp4, ++ t4;
- if(cnt[i + ] == ) -- tmp4, ++ t4;
- if(cnt[i] > ) -- tmp3, ++ t3;
- if(cnt[i + ] > ) -- tmp3, ++ t3;
- if(cnt[i + ] > ) -- tmp3, ++ t3;
- if(cnt[i + ] > ) -- tmp3, ++ t3;
- if(cnt[i + ] > ) -- tmp3, ++ t3;
- if(cnt[i] > ) -- tmp2, ++ t2;
- if(cnt[i + ] > ) -- tmp2, ++ t2;
- if(cnt[i + ] > ) -- tmp2, ++ t2;
- if(cnt[i + ] > ) -- tmp2, ++ t2;
- if(cnt[i + ] > ) -- tmp2, ++ t2;
- dfs(step + , now - );
- register int j = i + ;
- for(;j <= ;++ j)
- if(cnt[j])
- {
- -- cnt[j];
- if(cnt[j] == )++ t4, -- tmp4;
- if(cnt[j] > ) ++ t3, -- tmp3;
- if(cnt[j] > ) ++ t2, -- tmp2;
- dfs(step + , now - (j - i + ));
- }
- else break;
- -- j;
- for(;j >= i + ;-- j) ++ cnt[j];
- ++ cnt[i], ++ cnt[i + ], ++ cnt[i + ], ++ cnt[i + ], ++ cnt[i + ];
- tmp2 += t2, tmp3 += t3, tmp4 += t4;
- }
- }
- }
- //找四带二对牌
- if(tmp4 && tmp2 > && now >= )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] == )
- for(register int j = ;j <= ;++ j)
- if(cnt[j] > && i != j)
- for(register int k = j + ;k <= ;++ k)
- if(cnt[k] > && i != k)
- {
- cnt[j] -= ;
- cnt[k] -= ;
- cnt[i] -= ;
- tmp2 -= ;
- tmp3 -= ;
- tmp4 -= ;
- dfs(step + , now - );
- cnt[j] += ;
- cnt[k] += ;
- cnt[i] += ;
- tmp2 += ;
- tmp3 += ;
- tmp4 += ;
- }
- }
- //找四带二单牌
- if(tmp4 && now >= )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] == )
- {
- for(register int j = ;j <= ;++ j)
- if(cnt[j] > && i != j)
- for(register int k = j + ;k <= ;++ k)
- if(cnt[k] > && i != k)
- {
- int t2 = , t3 = , t4 = ;
- -- cnt[j];
- -- cnt[k];
- if(cnt[j] == ) -- tmp4, ++ t4;
- if(cnt[j] > ) -- tmp3, ++ t3;
- if(cnt[j] > ) -- tmp2, ++ t2;
- if(cnt[k] == ) -- tmp4, ++ t4;
- if(cnt[k] > ) -- tmp3, ++ t3;
- if(cnt[k] > ) -- tmp2, ++ t2;
- cnt[i] -= ;
- tmp4 -= ;
- tmp3 -= ;
- tmp2 -= ;
- dfs(step + , now - );
- ++ cnt[j];
- ++ cnt[k];
- cnt[i] += ;
- tmp4 += + t4;
- tmp3 += + t3;
- tmp2 += + t2;
- }
- if(cnt[] > )
- {
- cnt[] -= ;
- cnt[i] -= ;
- tmp4 -= ;
- tmp2 -= ;
- dfs(step + , now - );
- tmp4 += ;
- tmp2 += ;
- cnt[] += ;
- cnt[i] += ;
- }
- }
- }
- //找三带二
- if(tmp3 && tmp2 && now >= )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] > )
- for(register int j = ;j <= ;++ j)
- if(cnt[j] > && i != j)
- {
- cnt[j] -= ;
- cnt[i] -= ;
- tmp2 -= ;
- tmp3 -= ;
- dfs(step + , now - );
- cnt[j] += ;
- cnt[i] += ;
- tmp2 += ;
- tmp3 += ;
- }
- }
- //找三带一
- if(tmp3 && now >= )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] > )
- {
- cnt[i] -= ;
- int t2 = , t3 = , t4 = ;
- if(cnt[i] == ) -- tmp4, ++ t4;
- if(cnt[i] > ) -- tmp3, ++ t3;
- if(cnt[i] > ) -- tmp2, ++ t2;
- tmp3 -= ;
- tmp2 -= ;
- dfs(step + , now - );
- cnt[i] += ;
- tmp3 += + t3;
- tmp2 += + t2;
- tmp4 += t4;
- for(register int j = ;j <= ;++ j)
- if(cnt[j] > && i != j)
- {
- int t1 = , t2 = , t3 = ;
- if(cnt[j] == ) -- tmp4, ++ t4;
- if(cnt[j] > ) -- tmp3, ++ t3;
- if(cnt[j] > ) -- tmp2, ++ t2;
- cnt[j] -= ;
- cnt[i] -= ;
- tmp3 -= ;
- tmp2 -= ;
- dfs(step + , now - );
- cnt[j] += ;
- cnt[i] += ;
- tmp4 + t4;
- tmp3 += + t3;
- tmp2 += + t2;
- }
- }
- }
- //找裸四
- if(tmp4 > )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] == )
- {
- cnt[i] -= ;
- tmp4 -= ;
- tmp3 -= ;
- tmp2 -= ;
- dfs(step + , now - );
- cnt[i] += ;
- tmp4 += ;
- tmp3 += ;
- tmp2 += ;
- }
- }
- //找对子
- if(tmp2 > )
- {
- for(register int i = ;i <= ;++ i)
- if(cnt[i] > )
- {
- cnt[i] -= ;
- tmp2 -= ;
- dfs(step + , now - );
- tmp2 += ;
- cnt[i] += ;
- }
- }
- }
- int main()
- {
- read(t), read(n);
- for(;t;-- t)
- {
- memset(cnt, , sizeof(cnt));
- ans = n;
- for(register int j = ;j <= n;++ j)
- {
- tmp4 = tmp2 = tmp3 = ;
- s[] = s[] = ;
- scanf("%s", s + );
- if(s[] == '') ++ cnt[];
- else if(s[] == '') ++ cnt[];
- else if(s[] == '' && s[] == '') ++ cnt[];
- else if(s[] == '' && s[] == '') ++ cnt[];
- else if(s[] == '' && s[] == '') ++ cnt[];
- else if(s[] == '' && s[] == '') ++ cnt[];
- else if(s[] == '') ++ cnt[];
- else ++ cnt[s[] - ''];
- for(register int i = ;i <= ;++ i)
- {
- if(cnt[i] > ) ++ tmp2;
- if(cnt[i] > ) ++ tmp3;
- if(cnt[i] == ) ++ tmp4;
- }
- scanf("%s", s + );
- }
- dfs(, n);
- printf("%d\n", ans);
- }
- return ;
- }
TYVJ4239
TYVJ4239 [NOIP2015提高组DayT3]斗地主的更多相关文章
- NOIP2015提高组D1T3 斗地主
问一副排n张,n<=23最少打几次打完,数据组数T<=100. 面向数据编程.. 前30分:乱暴力?没有顺子,把单.对子.炸弹.三张.王炸.三带一判一次即可. 前70分:状压,先预处理哪些 ...
- 【题解】NOIP2015提高组 复赛
[题解]NOIP2015提高组 复赛 传送门: 神奇的幻方 \([P2615]\) 信息传递 \([P2661]\) 斗地主 \([P2668]\) 跳石头 \([P2678]\) 子串 \([P26 ...
- [NOIP2015] 提高组 洛谷P2615 神奇的幻方
题目描述 幻方是一种很神奇的N*N矩阵:它由数字1,2,3,……,N*N构成,且每行.每列及两条对角线上的数字之和都相同. 当N为奇数时,我们可以通过以下方法构建一个幻方: 首先将1写在第一行的中间. ...
- 洛谷-神奇的幻方-NOIP2015提高组复赛
题目描述 幻方是一种很神奇的N*N矩阵:它由数字1,2,3,--,N*N构成,且每行.每列及两条对角线上的数字之和都相同. 当N为奇数时,我们可以通过以下方法构建一个幻方: 首先将1写在第一行的中间. ...
- 洛谷 P2678 & [NOIP2015提高组] 跳石头
题目链接 https://www.luogu.org/problemnew/show/P2678 题目背景 一年一度的“跳石头”比赛又要开始了! 题目描述 这项比赛将在一条笔直的河道中进行,河道中分布 ...
- 【数据结构】运输计划 NOIP2015提高组D2T3
[数据结构]运输计划 NOIP2015提高组D2T3 >>>>题目 [题目描述] 公元 2044 年,人类进入了宇宙纪元.L 国有 n 个星球,还有 n−1 条双向航道,每条航 ...
- 【二分查找】 跳石头NOIP2015提高组 D2T1
[二分查找]跳石头NOIP2015提高组 D2T1 >>>>题目 [题目描述] 一年一度的“跳石头”比赛又要开始了! 这项比赛将在一条笔直的河道中进行,河道中分布着一些巨大岩石 ...
- 刷题总结——子串(NOIP2015提高组)
题目: 题目背景 NOIP2015 提高组 Day2 T2 题目描述 有两个仅包含小写英文字母的字符串 A 和 B .现在要从字符串 A 中取出 k 个互不重叠的非空子串,然后把这 k 个子串按照其在 ...
- noip2015 提高组 day1t1 神奇的幻方
题目描述 幻方是一种很神奇的N*N矩阵:它由数字1,2,3,--,N*N构成,且每行.每列及两条对角线上的数字之和都相同. 当N为奇数时,我们可以通过以下方法构建一个幻方: 首先将1写在第一行的中间. ...
随机推荐
- Python(四)基础篇之「文件对象&错误处理」
[笔记]Python(四)基础篇之「文件对象&错误处理」 2016-12-08 ZOE 编程之魅 Python Notes: ★ 如果你是第一次阅读,推荐先浏览:[重要公告]文章更新. ...
- Cesium官方教程10--高级粒子特效
原文地址:https://cesiumjs.org/tutorials/Particle-Systems-More-Effects-Tutorial/ 高级粒子系统特效 这篇教程学习更多的效果,包括天 ...
- PAT甲级——A1008 Elevator
The highest building in our city has only one elevator. A request list is made up with N positive nu ...
- 07_Hibernate多事务并发运行时并发问题检索方式
什么是事务? 事务(Transaction)是并发控制的单位,是用户定义的一个操作序列.这些操作要么都做,要么都不做,是一个不可分割的工作单位. 事务就是逻辑上的一组操作,要么全都成功,要么全都失败 ...
- 【LGP5112】FZOUTSY
题目 如果是\(hash\)做法的话显然就是把每一个位置后面的\(k\)个位置的hash值拿出来做一个莫队板子就好了 考虑一下牛逼的\(SAM\) 我们完全可以构造出来一棵后缀树,对于每个点找到其祖先 ...
- line-height影响排版
父级div设置了line-height值,子级div会继承line-height.如果不想子级元素继承,给子级元素设置line-height:normal.
- 复制字符串 _strdup _wcsdup _mbsdup
Duplicate strings.函数定义: char *_strdup( const char *strSource ); wchar_t *_wcsdup( const wchar_t *str ...
- [转]WPF更换主题
如果要做到一个应用程序其基本的内容不变,但改变整个应用程序的外观可以这样做: 对于每一套外观定义一个ResourceDictionary 在应用程序中,动态加载此应用程序(或窗体)的Resource ...
- SQL中distinct 和 row_number() over() 的区别及用法
1 前言 在咱们编写 SQL 语句操作数据库中的数据的时候,有可能会遇到一些不太爽的问题,例如对于同一字段拥有相同名称的记录,我们只需要显示一条,但实际上数据库中可能含有多条拥有相同名称的记录,从而在 ...
- JavaSE_03_Thread类02
1.1 线程状态概述 当线程被创建并启动以后,它既不是一启动就进入了执行状态,也不是一直处于执行状态.在线程的生命周期中, 有几种状态呢?在API中 java.lang.Thread.State 这个 ...